#!/usr/bin/perl 

use Getopt::Std;
getopts('i:o:');

$file1=$opt_i;
$file2=$opt_o;
if(($opt_i eq ''))
{
    print "USAGE: nuc2tnc -i <input file> -o Output file\n";
    print "-i\tSequence in S-FASTA format\n";
    print "-o\tOutput file\n"; 
    exit();
}
# ============================================================#
#-------------------------------------------------------------#
#                    Starting main program                    #
#-------------------------------------------------------------#
$aa = "#ACGU";
if (($opt_i ne '')&&($opt_o ne ''))
{
    open(FP1,"$file1");
    open(FP2,">$file2");

while($t1=<FP1>){
    chomp($t1);
    uc($t1);
    $c1 = substr($t1,0,2);
    if($c1 =~ ">")
    {
	@ti = split("##",$t1);
	@ti1 = split("",$ti[1]);
	$ti[1] =~ s/T/U/g;	    
	$le = length ($ti[1]);
	$len=$le-2;
	for($i1=1; $i1 <= 4; $i1++){
	    for($i2=2; $i2 <= 4; $i2++){
		for($i3=1; $i3 <= 4; $i3++)
		{
		    $comp[$i1][$i2][$i3]=0;
		    #print "[$i1][$i2]\n";
		    
		}
	    }
	    
	}
	for($j1 = 0; $j1 < $#ti1; $j1++){
	    $c1 = $ti1[$j1];
	    $in1 = index($aa,$c1);
	    $c2 = $ti1[$j1+1];
	    $in2 = index($aa,$c2);
	    $c3 = $ti1[$j1+2];
	    $in3 = index($aa,$c3);
	    $comp[$in1][$in2][$in3]++;
	    #print "##$comp[4][4]\n";
	}
	$count=0;
	for($i1=1; $i1 <= 4; $i1++)
	{
	    for($i2=1; $i2 <= 4; $i2++)
	    {
		for($i3=1;$i3<=4; $i3++)
		{
		    $perc=($comp[$i1][$i2][$i3])*100/$len;
		    $count++;
		    if($count <= 63)
		    {
			printf(FP2"%5.3f,",$perc);
		    }
		    else
		    {
			printf(FP2"%5.3f",$perc);
		    }
		    $comp[$i1][$i2][$i3]=0;
		    
		}
	    }
	}
	print FP2 "\n";
    }
    
}
    close FP1;
    close FP2;
exit();    
}
# ============================================================#
#-------------------------------------------------------------#
#             Starting for dispaly on terminal                #
#-------------------------------------------------------------#

if (($opt_i ne '')&&($opt_o eq ''))
{

    open(FP1,"$file1");
    while($t1=<FP1>){
	chomp($t1);
	uc($t1);
	$c1 = substr($t1,0,2);
	if($c1 =~ ">")
	{
	    @ti = split("##",$t1);
	    @ti1 = split("",$ti[1]);
	    $ti[1] =~ s/T/U/g;	    
	    $le = length ($ti[1]);
	    $len=$le-2;
	    for($i1=1; $i1 <= 4; $i1++){
		for($i2=2; $i2 <= 4; $i2++){
		    for($i3=1; $i3 <= 4; $i3++)
		    {
			$comp[$i1][$i2][$i3] = 0;		
		    }
		}
	    }

	    for($j1 = 0; $j1 < $#ti1; $j1++){
		$c1 = $ti1[$j1];
		$in1 = index($aa,$c1);
		$c2 = $ti1[$j1+1];
		$in2 = index($aa,$c2);
		$c3 = $ti1[$j1+2];
		$in3 = index($aa,$c3);
		$comp[$in1][$in2][$in3]++;
	    }
	    for($i1=1; $i1 <= 4; $i1++)
	    {
		for($i2=1; $i2 <= 4; $i2++)
		{
		    for($i3=1;$i3<=4; $i3++)
		    {
			$perc=($comp[$i1][$i2][$i3])*100/$len;
			$count++;
			if($count <= 63)
			{
			    printf("%5.3f,",$perc);
			}
			else
			{
			    printf("%5.3f",$perc);
			}
			printf("%5.3f,",$perc);
			$comp[$i1][$i2][$i3]=0;
		    }
		}
	    }
	    print "\n";
	}
    }
    close FP1;
}

